// SpiritTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SpiritTest.h"
#include "SpiritTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpiritTestDlg dialog

CSpiritTestDlg::CSpiritTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpiritTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpiritTestDlg)
	m_intValue = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSpiritTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpiritTestDlg)
	DDX_Control(pDX, IDC_SPIRITCTRL_ST, m_scTest);
	DDX_Text(pDX, IDC_EDIT_VALUE, m_intValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSpiritTestDlg, CDialog)
	//{{AFX_MSG_MAP(CSpiritTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_FWD, OnButtonFwd)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_TL, OnButtonTl)
	ON_BN_CLICKED(IDC_BUTTON_TR, OnButtonTr)
	ON_BN_CLICKED(IDC_BUTTON_RWD, OnButtonRwd)
	ON_BN_CLICKED(IDC_BUTTON_VALUE, OnButtonValue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpiritTestDlg message handlers

BOOL CSpiritTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	if(!m_scTest.InitComm())
	{
		MessageBox("ʱȭ  ");
	}
	m_scTest.SetSensorType(1,3);
	m_scTest.SetSensorMode(0,0,0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSpiritTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSpiritTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSpiritTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSpiritTestDlg::OnOK() 
{
	// TODO: Add extra validation here
	m_scTest.CloseComm();

	CDialog::OnOK();
}

void CSpiritTestDlg::OnButtonStop() 
{
	// TODO: Add your control notification handler code here
	m_scTest.Off("02");
}

void CSpiritTestDlg::OnButtonFwd() 
{
	// TODO: Add your control notification handler code here
	m_scTest.SetFwd("02");
	m_scTest.On("02");
	m_scTest.Off("02");
}


void CSpiritTestDlg::OnButtonTl() 
{
	// TODO: Add your control notification handler code here
	m_scTest.SetFwd("2");
	m_scTest.SetRwd("0");
	m_scTest.On("02");
	m_scTest.Off("02");
}

void CSpiritTestDlg::OnButtonTr() 
{
	// TODO: Add your control notification handler code here
	m_scTest.SetFwd("0");
	m_scTest.SetRwd("2");
	m_scTest.On("02");
	m_scTest.Off("02");
}

void CSpiritTestDlg::OnButtonRwd() 
{
	// TODO: Add your control notification handler code here
	m_scTest.SetRwd("02");
	m_scTest.On("02");
	m_scTest.Off("02");	
}

void CSpiritTestDlg::OnButtonValue() 
{
	// TODO: Add your control notification handler code here
	m_intValue = m_scTest.Poll(9,1);
	UpdateData(FALSE);
}
